import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
import 'package:get/get.dart';
import 'package:wow_views/interfaces/interface_action.dart';
import 'package:wowit/image_url.dart';
import 'package:wowit/methods.dart';
import 'package:wowit/widgets/wow_icon.dart';
import 'package:wowit/widgets/wow_image.dart';

class DanhSachNamDoc2 {
  Widget getMainView(Map<String, dynamic> data, String tableName) {
    var dsSuKien = _getData(data['data'],tableName);
    var dsAction = Methods.getList(data, 'dsAction');
    IActionEvent iAction = data['ActionEvent'] as IActionEvent;
    return ListView.builder(
      itemBuilder: (context, index) {
        DateTime? thoiGian = Methods.getDateTime(dsSuKien?[index], 'createDate');
        return InkWell(
          onTap: () {
            if (kDebugMode) {
              print('onTap item ds nam doc 2 - ID:3');
            }
            iAction.actionCompoment(3, dsAction,
                idData: Methods.getInt(dsSuKien?[index], 'ID', defaultValue: 0),
                params: {
                  '@id': Methods.getInt(dsSuKien?[index], 'ID', defaultValue: 0)
                });
          },
          onLongPress: () {
            if (kDebugMode) {
              print('onLongTap item ds nam doc 2');
            }
            // DynamicView.actionCompomentView(3, dsAction,idData: Methods.getInt(dsSuKien[index], 'ID'));
          },
          child: Card(
            child: Column(
              crossAxisAlignment: CrossAxisAlignment.start,
              children: [
                _hinhAnh(dsSuKien![index]),
                Padding(
                  padding: const EdgeInsets.all(8.0),
                  child: Text(
                    Methods.getString(dsSuKien[index], 'title'),
                    maxLines: 1,
                    style: const TextStyle(
                      color: Colors.black,
                      fontWeight: FontWeight.normal,
                      fontSize: 16,
                    ),
                  ),
                ),
                if(thoiGian!= null)...[
                  Padding(
                  padding: const EdgeInsets.only(bottom: 8, right: 8, left: 8),
                  child: _thoGian(
                    Methods.showDate(
                      Methods.getDateTime(dsSuKien[index], 'createDate')!,
                    ),
                  ),
                )
                ]
              ],
            ),
          ),
        );
      },
      itemCount: dsSuKien!.length,
      physics: const NeverScrollableScrollPhysics(),
      shrinkWrap: true,
    );
  }

  List<Map<String,Object?>>? _getData(Map<String, dynamic> data,String tableName){
    List<Map<String,Object?>> tData=[];
    for(var item in Methods.getList(data, tableName)){
      int id = Methods.getInt(item, 'ID');
      item['dsTrangThai'] = Methods.getListChildTable(data as Map<String, List<Map<String, Object?>>?>?,
       id, 'dsTrangThai',keyRef: 'idSuKien');
      tData.add(item);
    }
    return tData;
  }

  Widget _hinhAnh(Map<String, Object?> data) {
    List<Map<String,Object?>> dsTrangThai = Methods.getList(data, 'dsTrangThai');
    return ClipRRect(
      borderRadius: const BorderRadius.only(
        topRight: Radius.circular(5),
        topLeft: Radius.circular(5),
      ),
      child: Stack(
        children: [
          WowImage(
            data,
            height: 200,
            width: Get.width,
          ),
          if (dsTrangThai.isNotEmpty) ...[
            Positioned(
              top: 8,
              right: 8,
              child: _wTrangThai(dsTrangThai),
            )
          ]
        ],
      ),
    );
  }

  Widget _wTrangThai(List<Map<String,Object?>> dsTrangThai) {
    Map<String,Object?> data= dsTrangThai[dsTrangThai.length-1];
    return Container(
      padding: const EdgeInsets.symmetric(horizontal: 8,vertical: 4),
      decoration: BoxDecoration(
          color: Methods.getColor(data, 'titlebackgroundColor'),
          borderRadius: BorderRadius.circular(4)),
      child: Text(
        Methods.getString(data, 'titleTrangThai'),
        style: TextStyle(color: Methods.getColor(data, 'color')),
      ),
    );
  }

  Widget _thoGian(String createDate) {
    return Row(
      children: [
        WowIcon(
          Methods.getURL(
            ImageByID.getUrlImage(2206),
          ),
          size: 20,
        ),
        const SizedBox(
          width: 8,
        ),
        Text(
          createDate,
          style: const TextStyle(
            color: Color(0xff6B6B6B),
            fontWeight: FontWeight.normal,
            fontSize: 16,
          ),
        )
      ],
    );
  }
}
